searchNodes=[{"doc":"","ref":"Membrane.RTCPEvent.html","title":"Membrane.RTCPEvent","type":"module"},{"doc":"Bin handling one RTP session, that may consist of multiple incoming and outgoing RTP streams. Incoming streams Incoming RTP streams can be connected via :rtp_input pads. As each pad can provide multiple RTP streams, they are distinguished basing on SSRC. Once a new stream is received, bin sends new_stream_notification_t/0 notification, meaning the parent should link Pad.ref(:output, ssrc) pad to consuming components. The stream is then depayloaded and forwarded via said pad. Outgoing streams To create an RTP stream, the source stream needs to be connected via Pad.ref(:input, ssrc) pad and the sink - via Pad.ref(:rtp_output, ssrc) . At least one of :encoding or :payload_type options of :rtp_output pad must be provided too. Payloaders and depayloaders Payloaders are Membrane elements that transform stream so that it can be put into RTP packets, while depayloaders work the other way round. Different codecs require different payloaders and depayloaders. Thus, to send or receive given codec via this bin, proper payloader/depayloader is needed. Payloaders and depayloaders can be found in membrane_rtp_X_plugin packages, where X stands for codec name. It's enough when such plugin is added to dependencies. RTCP RTCP packets for inbound stream can be provided either in-band or via a separate rtp_input pad instance. Corresponding receiver report packets will be sent back through rtcp_output with the same id as rtp_input for the RTP stream. RTCP for outbound stream is not yet supported. Bin options Passed via struct Membrane.RTP.SessionBin.t/0 fmt_mapping %{ RTP . payload_type_t ( ) =&gt; { RTP . encoding_name_t ( ) , RTP . clock_rate_t ( ) } } Default value: %{} Mapping of the custom payload types ( &gt; 95) custom_payloaders %{ RTP . encoding_name_t ( ) =&gt; module ( ) } Default value: %{} Mapping from encoding names to custom payloader modules custom_depayloaders %{ RTP . encoding_name_t ( ) =&gt; module ( ) } Default value: %{} Mapping from encoding names to custom depayloader modules rtcp_interval Time . t ( ) Default value: 5 |&gt; Membrane.Time.seconds() Interval between sending subseqent RTCP receiver reports. receiver_ssrc_generator ( local_ssrcs :: [ pos_integer ] , remote_ssrcs :: [ pos_integer ] -&gt; ssrc :: pos_integer ) Default value: &amp;Membrane.RTP.SessionBin.generate_receiver_ssrc/2 Function generating receiver SSRCs. Default one generates random SSRC that is not in local_ssrcs nor remote_ssrcs . secure? boolean Default value: false Specifies whether to use SRTP. Requires adding srtp dependency to work. srtp_policies [ ExLibSRTP.Policy . t ( ) ] Default value: [] List of SRTP policies to use for decrypting packets. Used only when secure? is set to true . See ExLibSRTP.Policy.t/0 for details. receiver_srtp_policies [ ExLibSRTP.Policy . t ( ) ] | nil Default value: nil List of SRTP policies to use for encrypting receiver reports and other receiver RTCP packets. Used only when secure? is set to true . Defaults to the value of srtp_policies . See ExLibSRTP.Policy.t/0 for details. Pads :rtp_input Availability :on_request Caps Membrane.RemoteStream , restrictions:&lt;br /&gt;&amp;nbsp;&amp;nbsp; type: :packetized ,&lt;br /&gt;&amp;nbsp;&amp;nbsp; content_format: one_of([nil, Membrane.RTP]) Demand unit :buffers Direction :input Mode :pull Name :rtp_input :input Availability :on_request Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :rtcp_output Availability :on_request Caps Membrane.RemoteStream , restrictions:&lt;br /&gt;&amp;nbsp;&amp;nbsp; type: :packetized ,&lt;br /&gt;&amp;nbsp;&amp;nbsp; content_format: Membrane.RTCP Demand unit :buffers Direction :output Mode :pull Name :rtcp_output :rtp_output Availability :on_request Caps Membrane.RemoteStream , restrictions:&lt;br /&gt;&amp;nbsp;&amp;nbsp; type: :packetized ,&lt;br /&gt;&amp;nbsp;&amp;nbsp; content_format: Membrane.RTP Demand unit :buffers Direction :output Mode :pull Name :rtp_output Options: payload_type RTP . payload_type_t ( ) | nil Default value: nil Payload type of output stream. If not provided, determined from :encoding . encoding RTP . encoding_name_t ( ) | nil Default value: nil Encoding name of output stream. If not provided, determined from :payload_type . clock_rate integer ( ) | nil Default value: nil Clock rate to use. If not provided, determined from :payload_type . :output Availability :on_request Caps :any Demand unit :buffers Direction :output Mode :pull Name :output Options: encoding RTP . encoding_name_t ( ) | nil Default value: nil Encoding name determining depayloader which will be used to produce output stream from RTP stream. clock_rate integer ( ) | nil Default value: nil Clock rate to use. If not provided, determined from fmt_mapping or defaults registered by proper plugins i.e. Membrane.RTP.X.Plugin where X is the name of codec corresponding to encoding . extensions [ extension_t ( ) ] Default value: [] List of extensions. Currently :vad is only supported. :vad will turn on Voice Activity Detection mechanism firing appropriate notifications when needed. Should be set only for audio tracks. For more information refer to Membrane.RTP.VAD module documentation. Extensions are applied in the same order as passed to the pad options.","ref":"Membrane.RTP.SessionBin.html","title":"Membrane.RTP.SessionBin","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTP.SessionBin","ref":"Membrane.RTP.SessionBin.html#membrane_pads/0","title":"Membrane.RTP.SessionBin.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTP.SessionBin.html#options/0","title":"Membrane.RTP.SessionBin.options/0","type":"function"},{"doc":"A module that will be spawned and linked just before a newly created :output pad representing a single RTP stream. Given extension config must be a valid Membrane.Filter . An extension will be spawned inside the bin under {extension_name :: atom(), ssrc} name. Currently supported extensions are: Membrane.RTP.VAD Example usage {:vad, %Mebrane.RTP.VAD{time_window: 1_000_000}}","ref":"Membrane.RTP.SessionBin.html#t:extension_t/0","title":"Membrane.RTP.SessionBin.extension_t/0","type":"type"},{"doc":"","ref":"Membrane.RTP.SessionBin.html#t:new_stream_notification_t/0","title":"Membrane.RTP.SessionBin.new_stream_notification_t/0","type":"type"},{"doc":"Options for pad :output","ref":"Membrane.RTP.SessionBin.html#t:output_pad_opts_t/0","title":"Membrane.RTP.SessionBin.output_pad_opts_t/0","type":"type"},{"doc":"Options for pad :rtp_output","ref":"Membrane.RTP.SessionBin.html#t:rtp_output_pad_opts_t/0","title":"Membrane.RTP.SessionBin.rtp_output_pad_opts_t/0","type":"type"},{"doc":"Struct containing options for Membrane.RTP.SessionBin","ref":"Membrane.RTP.SessionBin.html#t:t/0","title":"Membrane.RTP.SessionBin.t/0","type":"type"},{"doc":"Describes RTP Header defined in RFC3550 0 1 2 3 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | V = 2 | P | X | CC | M | PT | sequence number | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | timestamp | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | synchronization source ( SSRC ) identifier | + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + = + | contributing source ( CSRC ) identifiers | | ... . | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - +","ref":"Membrane.RTP.Header.html","title":"Membrane.RTP.Header","type":"module"},{"doc":"The interpretation of the marker is defined by a profile","ref":"Membrane.RTP.Header.html#t:marker/0","title":"Membrane.RTP.Header.marker/0","type":"type"},{"doc":"A 16-bit integer sequential number of a packet. Its initial value should be random.","ref":"Membrane.RTP.Header.html#t:sequence_number_t/0","title":"Membrane.RTP.Header.sequence_number_t/0","type":"type"},{"doc":"","ref":"Membrane.RTP.Header.html#t:t/0","title":"Membrane.RTP.Header.t/0","type":"type"},{"doc":"Timestamp of a packet in ticks of clock according to t:RTP.clock_rate_t/0 . Its initial value is random, so it should not be interpreted as an absolute time, but rather used to calculate time difference from other timestamps.","ref":"Membrane.RTP.Header.html#t:timestamp_t/0","title":"Membrane.RTP.Header.timestamp_t/0","type":"type"},{"doc":"This field identifies the version of RTP. The version defined by this specification is 2.","ref":"Membrane.RTP.Header.html#t:version/0","title":"Membrane.RTP.Header.version/0","type":"type"},{"doc":"Describes RTP Header Extension defined in RFC3550 0 1 2 3 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | defined by profile | length | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | header extension | | ... . |","ref":"Membrane.RTP.Header.Extension.html","title":"Membrane.RTP.Header.Extension","type":"module"},{"doc":"","ref":"Membrane.RTP.Header.Extension.html#t:t/0","title":"Membrane.RTP.Header.Extension.t/0","type":"type"},{"doc":"Element that buffers and reorders RTP packets based on sequence_number . Element options Passed via struct Membrane.RTP.JitterBuffer.t/0 clock_rate RTP . clock_rate_t ( ) Required latency Time . t ( ) Default value: 200 |&gt; Membrane.Time.milliseconds() Delay introduced by JitterBuffer Pads :input Availability :always Caps Membrane.RTP Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps Membrane.RTP Direction :output Mode :pull Name :output","ref":"Membrane.RTP.JitterBuffer.html","title":"Membrane.RTP.JitterBuffer","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTP.JitterBuffer","ref":"Membrane.RTP.JitterBuffer.html#membrane_pads/0","title":"Membrane.RTP.JitterBuffer.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTP.JitterBuffer.html#options/0","title":"Membrane.RTP.JitterBuffer.options/0","type":"function"},{"doc":"","ref":"Membrane.RTP.JitterBuffer.html#t:packet_index/0","title":"Membrane.RTP.JitterBuffer.packet_index/0","type":"type"},{"doc":"Struct containing options for Membrane.RTP.JitterBuffer","ref":"Membrane.RTP.JitterBuffer.html#t:t/0","title":"Membrane.RTP.JitterBuffer.t/0","type":"type"},{"doc":"JitterBuffer stats that can be used for Receiver report generation","ref":"Membrane.RTP.JitterBuffer.Stats.html","title":"Membrane.RTP.JitterBuffer.Stats","type":"module"},{"doc":"","ref":"Membrane.RTP.JitterBuffer.Stats.html#t:t/0","title":"Membrane.RTP.JitterBuffer.Stats.t/0","type":"type"},{"doc":"","ref":"Membrane.RTP.JitterBuffer.StatsEvent.html","title":"Membrane.RTP.JitterBuffer.StatsEvent","type":"module"},{"doc":"","ref":"Membrane.RTP.JitterBuffer.StatsRequestEvent.html","title":"Membrane.RTP.JitterBuffer.StatsRequestEvent","type":"module"},{"doc":"Defines a struct describing an RTP packet and a way to parse and serialize it. Based on RFC3550","ref":"Membrane.RTP.Packet.html","title":"Membrane.RTP.Packet","type":"module"},{"doc":"","ref":"Membrane.RTP.Packet.html#identify/1","title":"Membrane.RTP.Packet.identify/1","type":"function"},{"doc":"","ref":"Membrane.RTP.Packet.html#parse/1","title":"Membrane.RTP.Packet.parse/1","type":"function"},{"doc":"","ref":"Membrane.RTP.Packet.html#serialize/2","title":"Membrane.RTP.Packet.serialize/2","type":"function"},{"doc":"","ref":"Membrane.RTP.Packet.html#t:t/0","title":"Membrane.RTP.Packet.t/0","type":"type"},{"doc":"This module contains utility to translate numerical payload type into an atom value.","ref":"Membrane.RTP.Packet.PayloadType.html","title":"Membrane.RTP.Packet.PayloadType","type":"module"},{"doc":"Gets the clock rate from numerical payload type according to RFC3551 . For quick reference check datasheet .","ref":"Membrane.RTP.Packet.PayloadType.html#get_clock_rate/1","title":"Membrane.RTP.Packet.PayloadType.get_clock_rate/1","type":"function"},{"doc":"Gets the name of used encoding from numerical payload type according to RFC3551 . For quick reference check datasheet .","ref":"Membrane.RTP.Packet.PayloadType.html#get_encoding_name/1","title":"Membrane.RTP.Packet.PayloadType.get_encoding_name/1","type":"function"},{"doc":"Checks if numerical payload type should be assigned to format type dynamically.","ref":"Membrane.RTP.Packet.PayloadType.html#is_dynamic/1","title":"Membrane.RTP.Packet.PayloadType.is_dynamic/1","type":"function"},{"doc":"Parses RTP packets. Outputs each packet payload as a separate Membrane.Buffer . Attaches the following metadata under :rtp key: :timestamp , :sequence_number , :ssrc , :payload_type , :marker , :extension . See Membrane.RTP.Header for their meaning and specifications. Pads :input Availability :always Caps Membrane.RemoteStream , restrictions:&lt;br /&gt;&amp;nbsp;&amp;nbsp; type: :packetized ,&lt;br /&gt;&amp;nbsp;&amp;nbsp; content_format: one_of([nil, Membrane.RTP]) Demand unit :buffers Direction :input Mode :pull Name :input :rtcp_output Availability :on_request Caps :any Direction :output Mode :push Name :rtcp_output :output Availability :always Caps Membrane.RTP Direction :output Mode :pull Name :output","ref":"Membrane.RTP.Parser.html","title":"Membrane.RTP.Parser","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTP.Parser","ref":"Membrane.RTP.Parser.html#membrane_pads/0","title":"Membrane.RTP.Parser.membrane_pads/0","type":"function"},{"doc":"A filter separating RTP packets from different SSRCs into different outpts. When receiving a new SSRC, it creates a new pad and notifies its parent ( new_stream_notification_t/0 ) that should link the new output pad. Pads :input Availability :on_request Caps Membrane.RTP Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :on_request Caps Membrane.RTP Direction :output Mode :pull Name :output","ref":"Membrane.RTP.SSRCRouter.html","title":"Membrane.RTP.SSRCRouter","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTP.SSRCRouter","ref":"Membrane.RTP.SSRCRouter.html#membrane_pads/0","title":"Membrane.RTP.SSRCRouter.membrane_pads/0","type":"function"},{"doc":"Notification sent when an RTP packet with new SSRC arrives and new output pad should be linked","ref":"Membrane.RTP.SSRCRouter.html#t:new_stream_notification_t/0","title":"Membrane.RTP.SSRCRouter.new_stream_notification_t/0","type":"type"},{"doc":"Serializes RTP payload to RTP packets by adding the RTP header to each of them. Accepts the following metadata under :rtp key: :marker , :csrcs , :extension . See Membrane.RTP.Header for their meaning and specifications. Element options Passed via struct Membrane.RTP.Serializer.t/0 ssrc RTP . ssrc_t ( ) Required payload_type RTP . payload_type_t ( ) Required clock_rate RTP . clock_rate_t ( ) Required alignment pos_integer ( ) Default value: 1 Number of bytes that each packet should be aligned to. Alignment is achieved by adding RTP padding. Pads :input Availability :always Caps Membrane.RTP Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps Membrane.RemoteStream , restrictions:&lt;br /&gt;&amp;nbsp;&amp;nbsp; type: :packetized ,&lt;br /&gt;&amp;nbsp;&amp;nbsp; content_format: Membrane.RTP Direction :output Mode :pull Name :output","ref":"Membrane.RTP.Serializer.html","title":"Membrane.RTP.Serializer","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTP.Serializer","ref":"Membrane.RTP.Serializer.html#membrane_pads/0","title":"Membrane.RTP.Serializer.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTP.Serializer.html#options/0","title":"Membrane.RTP.Serializer.options/0","type":"function"},{"doc":"Struct containing options for Membrane.RTP.Serializer","ref":"Membrane.RTP.Serializer.html#t:t/0","title":"Membrane.RTP.Serializer.t/0","type":"type"},{"doc":"Serializer stats that can be used for Sender Report(SR) generation","ref":"Membrane.RTP.Serializer.Stats.html","title":"Membrane.RTP.Serializer.Stats","type":"module"},{"doc":"","ref":"Membrane.RTP.Serializer.Stats.html#t:t/0","title":"Membrane.RTP.Serializer.Stats.t/0","type":"type"},{"doc":"This bin gets a parsed RTP stream on input and outputs raw media stream. Its responsibility is to depayload the RTP stream and compensate the jitter. Bin options Passed via struct Membrane.RTP.StreamReceiveBin.t/0 clock_rate Membrane.RTP . clock_rate_t ( ) Required depayloader any Required local_ssrc Membrane.RTP . ssrc_t ( ) Required remote_ssrc Membrane.RTP . ssrc_t ( ) Required rtcp_interval Membrane.Time . t ( ) Required Pads :input Availability :always Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps :any Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.RTP.StreamReceiveBin.html","title":"Membrane.RTP.StreamReceiveBin","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTP.StreamReceiveBin","ref":"Membrane.RTP.StreamReceiveBin.html#membrane_pads/0","title":"Membrane.RTP.StreamReceiveBin.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTP.StreamReceiveBin.html#options/0","title":"Membrane.RTP.StreamReceiveBin.options/0","type":"function"},{"doc":"Struct containing options for Membrane.RTP.StreamReceiveBin","ref":"Membrane.RTP.StreamReceiveBin.html#t:t/0","title":"Membrane.RTP.StreamReceiveBin.t/0","type":"type"},{"doc":"Bin payloading and serializing media stream to RTP. Bin options Passed via struct Membrane.RTP.StreamSendBin.t/0 payloader module Required payload_type RTP . payload_type_t ( ) Required ssrc RTP . ssrc_t ( ) Required clock_rate RTP . clock_rate_t ( ) Required Pads :input Availability :always Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps :any Demand unit :buffers Direction :output Mode :pull Name :output","ref":"Membrane.RTP.StreamSendBin.html","title":"Membrane.RTP.StreamSendBin","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTP.StreamSendBin","ref":"Membrane.RTP.StreamSendBin.html#membrane_pads/0","title":"Membrane.RTP.StreamSendBin.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTP.StreamSendBin.html#options/0","title":"Membrane.RTP.StreamSendBin.options/0","type":"function"},{"doc":"Struct containing options for Membrane.RTP.StreamSendBin","ref":"Membrane.RTP.StreamSendBin.html#t:t/0","title":"Membrane.RTP.StreamSendBin.t/0","type":"type"},{"doc":"Simple vad based on audio level sent in RTP header. To make this module work appropriate RTP header extension has to be set in SDP offer/answer. If avg of audio level in packets in time_window exceeds vad_threshold it emits notification speech_notification_t/0 . When avg falls below vad_threshold and doesn't exceed it in the next vad_silence_timer it emits notification silence_notification_t/0 . Element options Passed via struct Membrane.RTP.VAD.t/0 time_window pos_integer ( ) Default value: 2000000000 Time window (in ns ) in which avg audio level is measured. min_packet_num pos_integer ( ) Default value: 50 Minimal number of packets to count avg audio level from. Speech won't be detected until there are enough packets. vad_threshold - 127 .. 0 Default value: -50 Audio level in dBov representing vad threshold. Values above are considered to represent voice activity. Value -127 represents digital silence. vad_silence_time pos_integer ( ) Default value: 300 Time to wait before emitting notification silence_notification_t/0 after audio track is no longer considered to represent speech. If at this time audio track is considered to represent speech again the notification will not be sent. Pads :input Availability :always Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps :any Direction :output Mode :pull Name :output","ref":"Membrane.RTP.VAD.html","title":"Membrane.RTP.VAD","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTP.VAD","ref":"Membrane.RTP.VAD.html#membrane_pads/0","title":"Membrane.RTP.VAD.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTP.VAD.html#options/0","title":"Membrane.RTP.VAD.options/0","type":"function"},{"doc":"Notification sent after detecting silence activity.","ref":"Membrane.RTP.VAD.html#t:silence_notification_t/0","title":"Membrane.RTP.VAD.silence_notification_t/0","type":"type"},{"doc":"Notification sent after detecting speech activity.","ref":"Membrane.RTP.VAD.html#t:speech_notification_t/0","title":"Membrane.RTP.VAD.speech_notification_t/0","type":"type"},{"doc":"Struct containing options for Membrane.RTP.VAD","ref":"Membrane.RTP.VAD.html#t:t/0","title":"Membrane.RTP.VAD.t/0","type":"type"},{"doc":"Parses RTCP Application-defined (APP) packets defined in RFC3550","ref":"Membrane.RTCP.AppPacket.html","title":"Membrane.RTCP.AppPacket","type":"module"},{"doc":"","ref":"Membrane.RTCP.AppPacket.html#t:t/0","title":"Membrane.RTCP.AppPacket.t/0","type":"type"},{"doc":"Parses and constructs RTCP BYE packets defined in RFC3550","ref":"Membrane.RTCP.ByePacket.html","title":"Membrane.RTCP.ByePacket","type":"module"},{"doc":"","ref":"Membrane.RTCP.ByePacket.html#t:t/0","title":"Membrane.RTCP.ByePacket.t/0","type":"type"},{"doc":"","ref":"Membrane.RTCP.FeedbackPacket.html","title":"Membrane.RTCP.FeedbackPacket","type":"behaviour"},{"doc":"","ref":"Membrane.RTCP.FeedbackPacket.html#c:decode/1","title":"Membrane.RTCP.FeedbackPacket.decode/1","type":"callback"},{"doc":"","ref":"Membrane.RTCP.FeedbackPacket.html#c:encode/1","title":"Membrane.RTCP.FeedbackPacket.encode/1","type":"callback"},{"doc":"","ref":"Membrane.RTCP.FeedbackPacket.html#t:t/0","title":"Membrane.RTCP.FeedbackPacket.t/0","type":"type"},{"doc":"","ref":"Membrane.RTCP.FeedbackPacket.FIR.html","title":"Membrane.RTCP.FeedbackPacket.FIR","type":"module"},{"doc":"","ref":"Membrane.RTCP.FeedbackPacket.PLI.html","title":"Membrane.RTCP.FeedbackPacket.PLI","type":"module"},{"doc":"","ref":"Membrane.RTCP.FeedbackPacket.TWCC.html","title":"Membrane.RTCP.FeedbackPacket.TWCC","type":"module"},{"doc":"Struct describing 32-bit header common to all RTCP packets","ref":"Membrane.RTCP.Header.html","title":"Membrane.RTCP.Header","type":"module"},{"doc":"","ref":"Membrane.RTCP.Header.html#parse/1","title":"Membrane.RTCP.Header.parse/1","type":"function"},{"doc":"","ref":"Membrane.RTCP.Header.html#serialize/2","title":"Membrane.RTCP.Header.serialize/2","type":"function"},{"doc":"","ref":"Membrane.RTCP.Header.html#t:packet_specific_t/0","title":"Membrane.RTCP.Header.packet_specific_t/0","type":"type"},{"doc":"","ref":"Membrane.RTCP.Header.html#t:packet_type_t/0","title":"Membrane.RTCP.Header.packet_type_t/0","type":"type"},{"doc":"","ref":"Membrane.RTCP.Header.html#t:t/0","title":"Membrane.RTCP.Header.t/0","type":"type"},{"doc":"Functions common to all RTCP Packets","ref":"Membrane.RTCP.Packet.html","title":"Membrane.RTCP.Packet","type":"behaviour"},{"doc":"Decodes binary with packet body (without header) into packet struct. Used by parse/1","ref":"Membrane.RTCP.Packet.html#c:decode/2","title":"Membrane.RTCP.Packet.decode/2","type":"callback"},{"doc":"Encodes packet struct into the tuple used by serialize/1","ref":"Membrane.RTCP.Packet.html#c:encode/1","title":"Membrane.RTCP.Packet.encode/1","type":"callback"},{"doc":"","ref":"Membrane.RTCP.Packet.html#parse/1","title":"Membrane.RTCP.Packet.parse/1","type":"function"},{"doc":"Converts packet structure into binary","ref":"Membrane.RTCP.Packet.html#serialize/1","title":"Membrane.RTCP.Packet.serialize/1","type":"function"},{"doc":"","ref":"Membrane.RTCP.Packet.html#t:t/0","title":"Membrane.RTCP.Packet.t/0","type":"type"},{"doc":"Membrane element. Element options Passed via struct Membrane.RTCP.Receiver.t/0 local_ssrc any Required remote_ssrc any Required report_interval any Required Pads :input Availability :always Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps :any Direction :output Mode :pull Name :output","ref":"Membrane.RTCP.Receiver.html","title":"Membrane.RTCP.Receiver","type":"module"},{"doc":"Returns pads descriptions for Membrane.RTCP.Receiver","ref":"Membrane.RTCP.Receiver.html#membrane_pads/0","title":"Membrane.RTCP.Receiver.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.RTCP.Receiver.html#options/0","title":"Membrane.RTCP.Receiver.options/0","type":"function"},{"doc":"Struct containing options for Membrane.RTCP.Receiver","ref":"Membrane.RTCP.Receiver.html#t:t/0","title":"Membrane.RTCP.Receiver.t/0","type":"type"},{"doc":"Parses and constructs RTCP Receiver Report defined in RFC3550","ref":"Membrane.RTCP.ReceiverReportPacket.html","title":"Membrane.RTCP.ReceiverReportPacket","type":"module"},{"doc":"","ref":"Membrane.RTCP.ReceiverReportPacket.html#t:t/0","title":"Membrane.RTCP.ReceiverReportPacket.t/0","type":"type"},{"doc":"Parses and constructs report blocks, which are parts of RTCP Sender and Receiver Reports defined in RFC3550","ref":"Membrane.RTCP.ReportPacketBlock.html","title":"Membrane.RTCP.ReportPacketBlock","type":"module"},{"doc":"","ref":"Membrane.RTCP.ReportPacketBlock.html#decode/1","title":"Membrane.RTCP.ReportPacketBlock.decode/1","type":"function"},{"doc":"","ref":"Membrane.RTCP.ReportPacketBlock.html#encode/1","title":"Membrane.RTCP.ReportPacketBlock.encode/1","type":"function"},{"doc":"","ref":"Membrane.RTCP.ReportPacketBlock.html#t:t/0","title":"Membrane.RTCP.ReportPacketBlock.t/0","type":"type"},{"doc":"Parses Source Description (SDES) RTCP Packets defined in RFC3550","ref":"Membrane.RTCP.SdesPacket.html","title":"Membrane.RTCP.SdesPacket","type":"module"},{"doc":"","ref":"Membrane.RTCP.SdesPacket.html#t:t/0","title":"Membrane.RTCP.SdesPacket.t/0","type":"type"},{"doc":"Parses and constructs RTCP Sender Report defined in RFC3550","ref":"Membrane.RTCP.SenderReportPacket.html","title":"Membrane.RTCP.SenderReportPacket","type":"module"},{"doc":"","ref":"Membrane.RTCP.SenderReportPacket.html#t:sender_info_t/0","title":"Membrane.RTCP.SenderReportPacket.sender_info_t/0","type":"type"},{"doc":"","ref":"Membrane.RTCP.SenderReportPacket.html#t:t/0","title":"Membrane.RTCP.SenderReportPacket.t/0","type":"type"},{"doc":"Converts SRTP packets to plain RTP. Requires adding srtp dependency to work. Element options Passed via struct Membrane.SRTP.Decryptor.t/0 policies [ ExLibSRTP.Policy . t ( ) ] Required List of SRTP policies to use for decrypting packets. See ExLibSRTP.Policy.t/0 for details. Pads :input Availability :always Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps :any Direction :output Mode :pull Name :output","ref":"Membrane.SRTP.Decryptor.html","title":"Membrane.SRTP.Decryptor","type":"module"},{"doc":"Returns pads descriptions for Membrane.SRTP.Decryptor","ref":"Membrane.SRTP.Decryptor.html#membrane_pads/0","title":"Membrane.SRTP.Decryptor.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.SRTP.Decryptor.html#options/0","title":"Membrane.SRTP.Decryptor.options/0","type":"function"},{"doc":"Struct containing options for Membrane.SRTP.Decryptor","ref":"Membrane.SRTP.Decryptor.html#t:t/0","title":"Membrane.SRTP.Decryptor.t/0","type":"type"},{"doc":"Converts plain RTP packets to SRTP. Requires adding srtp dependency to work. Element options Passed via struct Membrane.SRTP.Encryptor.t/0 policies [ ExLibSRTP.Policy . t ( ) ] Default value: [] List of SRTP policies to use for encrypting packets. See ExLibSRTP.Policy.t/0 for details. Pads :input Availability :always Caps :any Demand unit :buffers Direction :input Mode :pull Name :input :output Availability :always Caps :any Direction :output Mode :pull Name :output","ref":"Membrane.SRTP.Encryptor.html","title":"Membrane.SRTP.Encryptor","type":"module"},{"doc":"Returns pads descriptions for Membrane.SRTP.Encryptor","ref":"Membrane.SRTP.Encryptor.html#membrane_pads/0","title":"Membrane.SRTP.Encryptor.membrane_pads/0","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.SRTP.Encryptor.html#options/0","title":"Membrane.SRTP.Encryptor.options/0","type":"function"},{"doc":"Struct containing options for Membrane.SRTP.Encryptor","ref":"Membrane.SRTP.Encryptor.html#t:t/0","title":"Membrane.SRTP.Encryptor.t/0","type":"type"},{"doc":"Membrane RTP plugin This package provides bins and elements for sending and receiving RTP/SRTP and RTCP/SRTCP streams. It is a part of Membrane Multimedia Framework .","ref":"readme.html","title":"Membrane RTP plugin","type":"extras"},{"doc":"The package can be installed by adding membrane_rtp_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_rtp_plugin , &quot;~&gt; 0.5.0&quot; } , { :ex_libsrtp , &quot;~&gt; 0.1.0&quot; } # required only if SRTP/SRTCP support is needed ] end","ref":"readme.html#installation","title":"Membrane RTP plugin - Installation","type":"extras"},{"doc":"For usage examples, check the RTP demo . The docs can be found at HexDocs .","ref":"readme.html#usage","title":"Membrane RTP plugin - Usage","type":"extras"},{"doc":"Copyright 2020, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane RTP plugin - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]